part of viltage;

class CharNode {
  int x, y;
  String char = "x";
  String color = "#000000";
  String backgroundColor = null;
  String fontName = null;
  bool italic = null;
  bool bold = null;
  bool visible = true;
  
  CharNode(this.x, this.y, this.char) { }
  
  /* creates identical CharNode */
  CharNode copy() {
    CharNode newCn = new CharNode(x, y, char)
      ..color = color
      ..backgroundColor = backgroundColor
      ..bold = bold
      ..italic = italic
      ..fontName = fontName;
    
    return newCn;
  }
  
  /* creates identifiable string */
  String getString(VilTAGE viltage) {
    StringBuffer sb = new StringBuffer();
    sb.write(char+color);
    String vColor = backgroundColor == null?viltage.backgroundColor:backgroundColor;
    sb.write(vColor);
    String vItalic = italic == null?viltage.italic.toString():italic.toString();
    sb.write(vItalic);
    String vBold = bold == null?viltage.bold.toString():bold.toString();
    sb.write(vBold);
    String vFont = fontName == null?viltage.fontName:fontName;
    sb.write(vFont);
    
    return sb.toString();
  }
}