part of viltage;

class VilTAGESound {
  static List<VilTAGESound> sounds = new List<VilTAGESound>();

  AudioElement _audio;
  StreamController endedController = new StreamController();
  Stream onEnded;
  
  VilTAGESound(String source, {bool loop}) {
    _audio = new AudioElement();
    document.body.nodes.add(_audio);
    _audio.src = source;
    _audio.play();
    sounds.add(this);

    onEnded = endedController.stream;
    _audio.onEnded.listen((Event e) {endedController.add(e); });
    
  }

  play() {
    _audio.play();
  }

  stop() {
    _audio.pause();
  }

  setVolume(double volume) {
    _audio.volume = volume;
  }
}
