part of viltage;

class Input {
  static List<int> _keys = new List<int>();
  static List<int> _lastKeys = new List<int>();
  static List<int> _banKeys = new List<int>();
  
  static init() {
    window.onKeyDown.listen((KeyboardEvent e) {
      if (!(_keys[e.keyCode]!= 0)) {
        _keys[e.keyCode] = e.timeStamp;
      }
    });

    window.onKeyUp.listen((KeyboardEvent e) {
      _keys.remove(e.keyCode);
    });
  }

  static bool isHeld(int keyCode) => _keys[keyCode]!=0;
  
  static bool isPressed(int keyCode) => _lastKeys[keyCode]!=0;
  
  static load() {
    for(int i = 0; i < 256; i++) {
       if(_lastKeys[i]!=0 || _banKeys[i]!=0) {
         _lastKeys[i]=0;
         _banKeys[i] =1;
       } else if(_keys[i]!=0) {
         _lastKeys[i]= 0; 
       }
    }
  }
  
  static end() {
    for(int i = 0; i < 256; i++) {
      if(!(_keys[i]!=0) ) _banKeys[i]=1;
    }
  }
  
}